<?php
// echo "%%%%%%%%%%%%%%%%%%% ".$_REQUEST['node_id']." %%%%%%%%%%%%%%%%%%%" ;

$path = $_SERVER['DOCUMENT_ROOT'];
$ESIA_WIDGET_NOTREE=true;
include_once $path.'common.php';

// Gestion du table sorter
$params = array('filters'=>$_REQUEST['filters'],
	'order'=> $_REQUEST['cols'],
	'size'=>50,
	'paging'=>0);
if (isset($_GET['page']) && ! empty($_GET['page']))
{
	$params['paging'] = $_GET['page'];
}
if (isset($_GET['size']) && ! empty($_GET['size']))
{
	if ($_GET['size'] == 'all')
	{
		$_GET['size'] = 100;
	}
	$params['size'] = $_GET['size'];
}

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_EGIDESCAN');
$plugin_url = $arr[0]['apache_path'];
include_once $path.'/'.$plugin_url.'/model_ts_egidescan.php';
include_once $path.'/'.$plugin_url.'/common_egidescan.php';

//Gestion des langues du système / utilisateur pour les données traduite.
$lang_abre =LANG;
if($user->getLang()!="")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}

if(file_exists($path.'/'.$plugin_url.'/lang/' .$lang_abre.'.php'))
{
	include $path.'/'.$plugin_url.'/lang/' .$lang_abre.'.php';
}
$components = array();
try
{
	if($_GET['action']=='cve' || $_GET['action']=='acq' || $_GET['action']=='services' )
	{
	//	print_R($params);
		$treeview_type = $_GET['treeview'];
		$treeview_nodeid = $_GET['nodeid'];
	//	$treeview_nodelist = getDevicesOfAgentOrGroup($dbconnection,$user,$treeview_type,$treeview_nodeid);

		$mode_id_list = ( isset($_GET['mode']) && $_GET['mode'] == 'idList' );

		if( $_GET['action']=='cve' )
		{
			$data = Model_EgideScan_TableSort::ts_getListCVE($dbconnection,$mode_id_list,$treeview_type,$treeview_nodeid,$user->getId(),$params);
		}
		elseif( $_GET['action']=='acq' )
		{
			$data = Model_EgideScan_TableSort::ts_getListACQ($dbconnection,$mode_id_list,$treeview_type,$treeview_nodeid,$user->getId(),$params);
		}
		elseif( $_GET['action']=='services' )
		{
			$data = Model_EgideScan_TableSort::ts_getListSRV($dbconnection,$mode_id_list,$treeview_type,$treeview_nodeid,$user->getId(),$params);
		}

		if( $mode_id_list )
		{
			$ret = array();
			$key = array_shift(array_keys($data[0]));
			foreach($data as $row)
			{
				$value = str_replace('_','-',$key);
				$value.= '-'.$row[$key];

				$ret[] = $value;
			}
			echo json_encode($ret);
			exit(0);
		}

		if( $_GET['action']=='cve' )
		{
			$arr = array();
			$linkdialog = '<a class="adminTabs" href="'.$plugin_url.'/dialog_cve.php?action=';
			foreach($data['rows'] as $vul)
			{
				$id = $linkdialog.$vul['vul_id'].'">'.$vul['vul_id'].'</a>';
				$line = array();
				$line[''] = makeHtmlCheckBoxString("vul-id-".$vul['id']);
				$line[$lang['EGIDE_VULNERABILITY_ID']] = $id;
				$line[$lang['EGIDE_VULNERABILITY_PUBLISHING']] = $vul['publishing'];
				$line[$lang['EGIDE_VULNERABILITY_DESCRIPION']] = $vul['description'];
				$line[$lang['EGIDE_VULNERABILITY_SCORING']] = makeHtmlCssScoringString($vul['scoring']);
				$line[$lang['EGIDE_VULNERABILITY_SEVERITY']] = $vul['severity'];
				$line[$lang['EGIDE_VULNERABILITY_COMPLEXITY']] = $vul['complexity'];
				$line[$lang['EGIDE_VULNERABILITY_MATCH']] = $vul['number'];
				$arr[] = $line;
			}
		}
		elseif( $_GET['action']=='acq' )
		{
			$arr = array();
			foreach($data['rows'] as $acq)
			{
				$line = array();
				if( $acq['detect_state'] != 'CLOSED' )
				{
					$line[''] = makeHtmlCheckBoxString("vul-id-".$acq['id']);
				}
				else
				{
					$line[''] = '';
				}

				$line[$lang['EGIDE_VULNERABILITY_ID']] = $acq['vul_id'];
				$line[$lang['EGIDE_NODE']] = $acq['device_name'];
				$line[$lang['EGIDE_HISTORY_DIALOG_TABLE_PORT_SERVICE']] = $acq['service_name'];
				$line[$lang['EGIDE_ACQ_DATE']] = $acq['acq_date'];
				$line[$lang['EGIDE_VULNERABILITY_DESCRIPION']] = $acq['description'];
				$line[$lang['EGIDE_VULNERABILITY_SCORING']] = makeHtmlCssScoringString($acq['scoring']);
				$line[$lang['EGIDE_VULNERABILITY_SEVERITY']] = $acq['severity'];
				$line[$lang['EGIDE_VULNERABILITY_COMPLEXITY']] = $acq['complexity'];
				if($acq['detect_state'] == 'CLOSED')
				{
					$line[$lang['EGIDE_SCANNER_HISTORY_TABLE_STATE']] = "<td class='EventOK'>".$acq['detect_state']."</td>";
				}
				elseif($acq['detect_state'] == 'ACQUIT')
				{
					$line[$lang['EGIDE_SCANNER_HISTORY_TABLE_STATE']] = "<td class='EventPending'>".$acq['detect_state']."</td>";
				}
				$arr[] = $line;
			}
		}
		elseif( $_GET['action']=='services' )
		{
			$arr = array();
			$linkdialog = '<a class="adminTabs" href="'.$plugin_url.'/dialog_services.php?action=';
			foreach($data['rows'] as $srv)
			{
				$name = $linkdialog.$srv['srv_id'].'">'.$srv['srv_name'].'</a>';
				$line = array();
				$line[''] = makeHtmlCheckBoxString("srv-id-".$srv['srv_id']);
				$line[$lang['EGIDE_SERVICES_TABLE_SRV_NAME']] = $name;
				$line[$lang['EGIDE_SERVICES_TABLE_DEV_NAME']] = $srv['dev_name'];
				$line[$lang['EGIDE_SERVICES_TABLE_DEV_TYPE']] = $srv['dev_type'];
				$line[$lang['EGIDE_SERVICES_TABLE_DEV_ADDR']] = $srv['dev_addr'];
				$line[$lang['EGIDE_SERVICES_TABLE_AVG_SCORE']] = makeHtmlCssScoringString($srv['avg_score']);
				$line[$lang['EGIDE_SERVICES_TABLE_MAX_SCORE']] = makeHtmlCssScoringString($srv['max_score']);
				$line[$lang['EGIDE_SERVICES_TABLE_VUL_TOTAL']] = $srv['vul_total'];
				$line[$lang['EGIDE_SERVICES_TABLE_SRV_PRODUCT']] = $srv['srv_product'];
				$line[$lang['EGIDE_SERVICES_TABLE_SRV_VERSION']] = $srv['srv_version'];
				$line[$lang['EGIDE_SERVICES_TABLE_PORT_NAME']] = $srv['port_num'];
				$line[$lang['EGIDE_SERVICES_TABLE_PORT_TYPE']] = $srv['port_type'];
				$arr[] = $line;
			}
		}

		$json_array['headers']=array_keys($arr[0]);
		$json_array['rows']=$arr;
		$json_array['total_rows']=$data['total'];
		echo json_encode($json_array);
		exit(0);
	}
	else if($_GET['action']=='adv_cve')
	{
		//	print_R($params);
// 		include_once $path.'/inc/common_node_control.php';
// 		echo $node->getId();
		$nd = $_REQUEST['nodeid'] ;
		$vulnerabilities = Model_EgideScan_TableSort::ts_getListCVEByNode($dbconnection,$user->getId(),$params,$nd);
		$arr = array();
		$linkdialog = '<a class="adminTabs" href="'.$plugin_url.'/dialog_cve.php?action=';
		foreach($vulnerabilities['rows'] as $vul)
		{
			$id = $linkdialog.$vul['id'].'">'.$vul['id'].'</a>';
			//fonction définie dans common_egidescan
			$css = getCSSClassByscore($vul['scoring']);
			$tdscore = '<td class="'.$css.'">'.$vul['scoring'].'</td>';
			$line = array(
				$lang['EGIDE_VULNERABILITY_ID'] => $id,
				$lang['EGIDE_VULNERABILITY_PUBLISHING'] =>  $vul['publishing'],
				$lang['EGIDE_VULNERABILITY_DESCRIPION'] => $vul['description'],
				$lang['EGIDE_VULNERABILITY_SCORING'] => $tdscore,
				$lang['EGIDE_VULNERABILITY_SEVERITY'] =>  $vul['severity'],
				$lang['EGIDE_VULNERABILITY_COMPLEXITY'] =>  $vul['complexity'],
				$lang['EGIDE_VULNERABILITY_MATCH'] => $vul['number'],
				$lang['ACTION'] => '<img src="/theme/default/images/icn_errors_ack.png" class="button">'
			);
			$arr[] = $line;
		}
		$json_array['headers']=array_keys($arr[0]);
		$json_array['rows']=$arr;
		$json_array['total_rows']=$vulnerabilities['total'];
		echo json_encode($json_array);
		exit(0);
	}
	else
	{
		$components = Model_Inventory_TableSort::ts_getListInventory($dbconnection,$user->getId(),'HARDWARE',$params);
	}
	//echo '<pre>'; print_r($components);
	$arr = array();
	foreach($components['rows'] as $compo)
	{
		$name="";
		if( $compo['page_control'] != '')
		{
			$name = '<a id="linkn'.$compo['device_id'].'" href="'.$compo['page_control'].'">'.$compo['device'].'</a>';
		}
		$group = $compo['group'];
		if(empty($group))
		{
			$group="";
		}
		else
		{
			$group='<a href="/node_index.php?nodegroup='.$compo.['groupid'].'">'.$group.'</a>';
		}
        $state = $compo['state'];
        if($compo['state'] =='OK')
        {
             $state ='<td class="EventOK alignCenterTab">'.$state.'</td>';
        }
        elseif($compo['state'] =='OUTDATED')
        {
             $state ='<td class="EventCritical alignCenterTab">'.$state.'</td>';
        }
        else
        {
             $state ='<td class="EventNone alignCenterTab">'.$state.'</td>';
        }
		$line = array(
			$lang['INVENTORY_GROUP_NAME'] => $group,
			$lang['INVENTORY_NODE'] => $name,
			$lang['INVENTORY_DEVICE_TYPE'] => $compo['device_type'],
			$lang['INVENTORY_COMPONENT'] => $compo['component'],
			$lang['INVENTORY_VERSION'] => $compo['version'],
			$lang['INVENTORY_RULE_STATE'] => $state,
			$lang['INVENTORY_TYPE'] => $compo['type'],
			$lang['INVENTORY_DESCRIPTION'] => $compo['description'],
		);
		$arr[] = $line;

	}
	//Count
	$json_array['headers']=array_keys($arr[0]);
	$json_array['rows']=$arr;
	$json_array['total_rows']=$components['total'];
	echo json_encode($json_array);
}
catch (Exception $e)
{
	echo $e->getMessage();
}


function makeHtmlCheckBoxString($name)
{
	$str = "<td class='checkbox'>
				<div class='choixCustom'>
					<input type='checkbox' name='$name' onclick='enableOrDisableCheckButton(this)'/>
				</div>
			</td>";
	return $str;
}

function makeHtmlCssScoringString($score)
{
	$score = round($score,1);
	$css = getCSSClassByscore($score);
	$tdscore = '<td class="'.$css.'">'.$score.'</td>';
	return $tdscore;
}
?>
